Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 74430)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -4849,18 +5561,25 @@
         RtlCopyMemory(rr2 + tp.item->size, rr, sizeof(ROOT_REF) - 1 + rr->n);
         ExFreePool(rr);
         
-        delete_tree_item(Vcb, &tp, rollback);
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            ExFreePool(rr2);
+            return Status;
+        }
         
-        if (!insert_tree_item(Vcb, Vcb->root_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, rr2, rrsize, NULL, Irp, rollback)) {
-            ERR("error - failed to insert item\n");
+        Status = insert_tree_item(Vcb, Vcb->root_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, rr2, rrsize, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
             ExFreePool(rr2);
-            return STATUS_INTERNAL_ERROR;
+            return Status;
         }
     } else {
-        if (!insert_tree_item(Vcb, Vcb->root_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, rr, sizeof(ROOT_REF) - 1 + rr->n, NULL, Irp, rollback)) {
-            ERR("error - failed to insert item\n");
+        Status = insert_tree_item(Vcb, Vcb->root_root, searchkey.obj_id, searchkey.obj_type, searchkey.offset, rr, sizeof(ROOT_REF) - 1 + rr->n, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
             ExFreePool(rr);
-            return STATUS_INTERNAL_ERROR;
+            return Status;
         }
     }
     
@@ -4867,7 +5586,7 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL update_root_backref(device_extension* Vcb, UINT64 subvolid, UINT64 parsubvolid, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS STDCALL update_root_backref(device_extension* Vcb, UINT64 subvolid, UINT64 parsubvolid, PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp;
     UINT8* data;
@@ -4912,14 +5631,24 @@
         return Status;
     }
     
-    if (!keycmp(tp.item->key, searchkey))
-        delete_tree_item(Vcb, &tp, rollback);
+    if (!keycmp(tp.item->key, searchkey)) {
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            
+            if (datalen > 0)
+                ExFreePool(data);
+            
+            return Status;
+        }
+    }
     
     if (datalen > 0) {
-        if (!insert_tree_item(Vcb, Vcb->root_root, subvolid, TYPE_ROOT_BACKREF, parsubvolid, data, datalen, NULL, Irp, rollback)) {
-            ERR("error - failed to insert item\n");
+        Status = insert_tree_item(Vcb, Vcb->root_root, subvolid, TYPE_ROOT_BACKREF, parsubvolid, data, datalen, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
             ExFreePool(data);
-            return STATUS_INTERNAL_ERROR;
+            return Status;
         }
     }
     
@@ -4926,7 +5655,7 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS add_root_item_to_cache(device_extension* Vcb, UINT64 root, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS add_root_item_to_cache(device_extension* Vcb, UINT64 root, PIRP Irp) {
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
@@ -4943,7 +5672,6 @@
     
     if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
         ERR("could not find ROOT_ITEM for tree %llx\n", searchkey.obj_id);
-        int3;
         return STATUS_INTERNAL_ERROR;
     }
     
@@ -4959,11 +5687,16 @@
         
         RtlZeroMemory(((UINT8*)ri) + tp.item->size, sizeof(ROOT_ITEM) - tp.item->size);
         
-        delete_tree_item(Vcb, &tp, rollback);
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
         
-        if (!insert_tree_item(Vcb, Vcb->root_root, searchkey.obj_id, searchkey.obj_type, tp.item->key.offset, ri, sizeof(ROOT_ITEM), NULL, Irp, rollback)) {
-            ERR("insert_tree_item failed\n");
-            return STATUS_INTERNAL_ERROR;
+        Status = insert_tree_item(Vcb, Vcb->root_root, searchkey.obj_id, searchkey.obj_type, tp.item->key.offset, ri, sizeof(ROOT_ITEM), NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            return Status;
         }
     } else {
         tp.tree->write = TRUE;
@@ -4972,7 +5705,7 @@
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS flush_fileref(file_ref* fileref, LIST_ENTRY* batchlist, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS flush_fileref(file_ref* fileref, LIST_ENTRY* batchlist, PIRP Irp) {
     NTSTATUS Status;
     
     // if fileref created and then immediately deleted, do nothing
@@ -4991,9 +5724,9 @@
         DIR_ITEM *di, *di2;
         UINT32 crc32;
         
-        crc32 = calc_crc32c(0xfffffffe, (UINT8*)fileref->utf8.Buffer, fileref->utf8.Length);
+        crc32 = calc_crc32c(0xfffffffe, (UINT8*)fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
         
-        disize = sizeof(DIR_ITEM) - 1 + fileref->utf8.Length;
+        disize = sizeof(DIR_ITEM) - 1 + fileref->dc->utf8.Length;
         di = ExAllocatePoolWithTag(PagedPool, disize, ALLOC_TAG);
         if (!di) {
             ERR("out of memory\n");
@@ -5012,9 +5745,9 @@
 
         di->transid = fileref->fcb->Vcb->superblock.generation;
         di->m = 0;
-        di->n = (UINT16)fileref->utf8.Length;
+        di->n = (UINT16)fileref->dc->utf8.Length;
         di->type = fileref->fcb->type;
-        RtlCopyMemory(di->name, fileref->utf8.Buffer, fileref->utf8.Length);
+        RtlCopyMemory(di->name, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
         
         di2 = ExAllocatePoolWithTag(PagedPool, disize, ALLOC_TAG);
         if (!di2) {
@@ -5024,41 +5757,44 @@
         
         RtlCopyMemory(di2, di, disize);
 
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX, fileref->index,
-                                    di, disize, Batch_Insert, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+        Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
+                                        fileref->dc->index, di, disize, Batch_Insert);
+        if (!NT_SUCCESS(Status)) { 
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            return Status;
         }
         
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM, crc32,
-                                    di2, disize, Batch_DirItem, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+        Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM, crc32,
+                                        di2, disize, Batch_DirItem);
+        if (!NT_SUCCESS(Status)) { 
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            return Status;
         }
         
         if (fileref->parent->fcb->subvol == fileref->fcb->subvol) {
             INODE_REF* ir;
             
-            ir = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_REF) - 1 + fileref->utf8.Length, ALLOC_TAG);
+            ir = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_REF) - 1 + fileref->dc->utf8.Length, ALLOC_TAG);
             if (!ir) {
                 ERR("out of memory\n");
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
 
-            ir->index = fileref->index;
-            ir->n = fileref->utf8.Length;
-            RtlCopyMemory(ir->name, fileref->utf8.Buffer, ir->n);
+            ir->index = fileref->dc->index;
+            ir->n = fileref->dc->utf8.Length;
+            RtlCopyMemory(ir->name, fileref->dc->utf8.Buffer, ir->n);
         
-            if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
-                                        ir, sizeof(INODE_REF) - 1 + ir->n, Batch_InodeRef, Irp, rollback)) {
-                ERR("insert_tree_item_batch failed\n");
-                return STATUS_INTERNAL_ERROR;
+            Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
+                                            ir, sizeof(INODE_REF) - 1 + ir->n, Batch_InodeRef);
+            if (!NT_SUCCESS(Status)) { 
+                ERR("insert_tree_item_batch returned %08x\n", Status);
+                return Status;
             }
         } else {
             ULONG rrlen;
             ROOT_REF* rr;
 
-            rrlen = sizeof(ROOT_REF) - 1 + fileref->utf8.Length;
+            rrlen = sizeof(ROOT_REF) - 1 + fileref->dc->utf8.Length;
                 
             rr = ExAllocatePoolWithTag(PagedPool, rrlen, ALLOC_TAG);
             if (!rr) {
@@ -5067,17 +5803,17 @@
             }
             
             rr->dir = fileref->parent->fcb->inode;
-            rr->index = fileref->index;
-            rr->n = fileref->utf8.Length;
-            RtlCopyMemory(rr->name, fileref->utf8.Buffer, fileref->utf8.Length);
+            rr->index = fileref->dc->index;
+            rr->n = fileref->dc->utf8.Length;
+            RtlCopyMemory(rr->name, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
             
-            Status = add_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, rr, Irp, rollback);
+            Status = add_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, rr, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("add_root_ref returned %08x\n", Status);
                 return Status;
             }
             
-            Status = update_root_backref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, Irp, rollback);
+            Status = update_root_backref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("update_root_backref returned %08x\n", Status);
                 return Status;
@@ -5090,10 +5826,7 @@
         ANSI_STRING* name;
         DIR_ITEM* di;
         
-        if (fileref->oldutf8.Buffer)
-            name = &fileref->oldutf8;
-        else
-            name = &fileref->utf8;
+        name = &fileref->oldutf8;
 
         crc32 = calc_crc32c(0xfffffffe, (UINT8*)name->Buffer, name->Length);
 
@@ -5111,10 +5844,11 @@
         
         // delete DIR_ITEM (0x54)
         
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM,
-                                    crc32, di, sizeof(DIR_ITEM) - 1 + name->Length, Batch_DeleteDirItem, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+        Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM,
+                                        crc32, di, sizeof(DIR_ITEM) - 1 + name->Length, Batch_DeleteDirItem);
+        if (!NT_SUCCESS(Status)) { 
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            return Status;
         }
         
         if (fileref->parent->fcb->subvol == fileref->fcb->subvol) {
@@ -5128,23 +5862,24 @@
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
             
-            ir->index = fileref->index;
+            ir->index = fileref->oldindex;
             ir->n = name->Length;
             RtlCopyMemory(ir->name, name->Buffer, name->Length);
 
-            if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF,
-                                        fileref->parent->fcb->inode, ir, sizeof(INODE_REF) - 1 + name->Length, Batch_DeleteInodeRef, Irp, rollback)) {
-                ERR("insert_tree_item_batch failed\n");
-                return STATUS_INTERNAL_ERROR;
+            Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF,
+                                            fileref->parent->fcb->inode, ir, sizeof(INODE_REF) - 1 + name->Length, Batch_DeleteInodeRef);
+            if (!NT_SUCCESS(Status)) { 
+                ERR("insert_tree_item_batch returned %08x\n", Status);
+                return Status;
             }
         } else { // subvolume
-            Status = delete_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, fileref->parent->fcb->inode, name, Irp, rollback);
+            Status = delete_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, fileref->parent->fcb->inode, name, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("delete_root_ref returned %08x\n", Status);
                 return Status;
             }
             
-            Status = update_root_backref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, Irp, rollback);
+            Status = update_root_backref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("update_root_backref returned %08x\n", Status);
                 return Status;
@@ -5153,10 +5888,11 @@
         
         // delete DIR_INDEX (0x60)
         
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
-                                    fileref->index, NULL, 0, Batch_Delete, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+        Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
+                                        fileref->oldindex, NULL, 0, Batch_Delete);
+        if (!NT_SUCCESS(Status)) { 
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            return Status;
         }
         
         if (fileref->oldutf8.Buffer) {
@@ -5164,12 +5900,12 @@
             fileref->oldutf8.Buffer = NULL;
         }
     } else { // rename or change type
-        PANSI_STRING oldutf8 = fileref->oldutf8.Buffer ? &fileref->oldutf8 : &fileref->utf8;
+        PANSI_STRING oldutf8 = fileref->oldutf8.Buffer ? &fileref->oldutf8 : &fileref->dc->utf8;
         UINT32 crc32, oldcrc32;
         ULONG disize;
         DIR_ITEM *olddi, *di, *di2;
         
-        crc32 = calc_crc32c(0xfffffffe, (UINT8*)fileref->utf8.Buffer, fileref->utf8.Length);
+        crc32 = calc_crc32c(0xfffffffe, (UINT8*)fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
         
         if (!fileref->oldutf8.Buffer)
             oldcrc32 = crc32;
@@ -5188,15 +5924,16 @@
         
         // delete DIR_ITEM (0x54)
         
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM,
-                                    oldcrc32, olddi, sizeof(DIR_ITEM) - 1 + oldutf8->Length, Batch_DeleteDirItem, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+        Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM,
+                                        oldcrc32, olddi, sizeof(DIR_ITEM) - 1 + oldutf8->Length, Batch_DeleteDirItem);
+        if (!NT_SUCCESS(Status)) { 
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            return Status;
         }
 
         // add DIR_ITEM (0x54)
         
-        disize = sizeof(DIR_ITEM) - 1 + fileref->utf8.Length;
+        disize = sizeof(DIR_ITEM) - 1 + fileref->dc->utf8.Length;
         di = ExAllocatePoolWithTag(PagedPool, disize, ALLOC_TAG);
         if (!di) {
             ERR("out of memory\n");
@@ -5222,16 +5959,17 @@
         
         di->transid = fileref->fcb->Vcb->superblock.generation;
         di->m = 0;
-        di->n = (UINT16)fileref->utf8.Length;
+        di->n = (UINT16)fileref->dc->utf8.Length;
         di->type = fileref->fcb->type;
-        RtlCopyMemory(di->name, fileref->utf8.Buffer, fileref->utf8.Length);
+        RtlCopyMemory(di->name, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
         
         RtlCopyMemory(di2, di, disize);
         
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM, crc32,
-                                    di, disize, Batch_DirItem, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+        Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_ITEM, crc32,
+                                        di, disize, Batch_DirItem);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            return Status;
         }
         
         if (fileref->parent->fcb->subvol == fileref->fcb->subvol) {
@@ -5245,32 +5983,34 @@
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
 
-            ir->index = fileref->index;
+            ir->index = fileref->dc->index;
             ir->n = oldutf8->Length;
             RtlCopyMemory(ir->name, oldutf8->Buffer, ir->n);
         
-            if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
-                                        ir, sizeof(INODE_REF) - 1 + ir->n, Batch_DeleteInodeRef, Irp, rollback)) {
-                ERR("insert_tree_item_batch failed\n");
-                return STATUS_INTERNAL_ERROR;
+            Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
+                                            ir, sizeof(INODE_REF) - 1 + ir->n, Batch_DeleteInodeRef);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item_batch returned %08x\n", Status);
+                return Status;
             }
             
             // add INODE_REF (0xc)
             
-            ir2 = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_REF) - 1 + fileref->utf8.Length, ALLOC_TAG);
+            ir2 = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_REF) - 1 + fileref->dc->utf8.Length, ALLOC_TAG);
             if (!ir2) {
                 ERR("out of memory\n");
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
 
-            ir2->index = fileref->index;
-            ir2->n = fileref->utf8.Length;
-            RtlCopyMemory(ir2->name, fileref->utf8.Buffer, ir2->n);
+            ir2->index = fileref->dc->index;
+            ir2->n = fileref->dc->utf8.Length;
+            RtlCopyMemory(ir2->name, fileref->dc->utf8.Buffer, ir2->n);
         
-            if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
-                                        ir2, sizeof(INODE_REF) - 1 + ir2->n, Batch_InodeRef, Irp, rollback)) {
-                ERR("insert_tree_item_batch failed\n");
-                return STATUS_INTERNAL_ERROR;
+            Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->fcb->subvol, fileref->fcb->inode, TYPE_INODE_REF, fileref->parent->fcb->inode,
+                                            ir2, sizeof(INODE_REF) - 1 + ir2->n, Batch_InodeRef);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item_batch returned %08x\n", Status);
+                return Status;
             }
         } else { // subvolume
             ULONG rrlen;
@@ -5278,12 +6018,12 @@
             
             // FIXME - make sure this works with duff subvols within snapshots
             
-            Status = delete_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, fileref->parent->fcb->inode, oldutf8, Irp, rollback);
+            Status = delete_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, fileref->parent->fcb->inode, oldutf8, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("delete_root_ref returned %08x\n", Status);
             }
             
-            rrlen = sizeof(ROOT_REF) - 1 + fileref->utf8.Length;
+            rrlen = sizeof(ROOT_REF) - 1 + fileref->dc->utf8.Length;
             
             rr = ExAllocatePoolWithTag(PagedPool, rrlen, ALLOC_TAG);
             if (!rr) {
@@ -5292,17 +6032,17 @@
             }
             
             rr->dir = fileref->parent->fcb->inode;
-            rr->index = fileref->index;
-            rr->n = fileref->utf8.Length;
-            RtlCopyMemory(rr->name, fileref->utf8.Buffer, fileref->utf8.Length);
+            rr->index = fileref->dc->index;
+            rr->n = fileref->dc->utf8.Length;
+            RtlCopyMemory(rr->name, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
             
-            Status = add_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, rr, Irp, rollback);
+            Status = add_root_ref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, rr, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("add_root_ref returned %08x\n", Status);
                 return Status;
             }
             
-            Status = update_root_backref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, Irp, rollback);
+            Status = update_root_backref(fileref->fcb->Vcb, fileref->fcb->subvol->id, fileref->parent->fcb->subvol->id, Irp);
             if (!NT_SUCCESS(Status)) {
                 ERR("update_root_backref returned %08x\n", Status);
                 return Status;
@@ -5311,18 +6051,20 @@
         
         // delete DIR_INDEX (0x60)
         
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
-                                    fileref->index, NULL, 0, Batch_Delete, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+        Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
+                                        fileref->dc->index, NULL, 0, Batch_Delete);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            return Status;
         }
         
         // add DIR_INDEX (0x60)
         
-        if (!insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
-                                    fileref->index, di2, disize, Batch_Insert, Irp, rollback)) {
-            ERR("insert_tree_item_batch failed\n");
-            return STATUS_INTERNAL_ERROR;
+       Status = insert_tree_item_batch(batchlist, fileref->fcb->Vcb, fileref->parent->fcb->subvol, fileref->parent->fcb->inode, TYPE_DIR_INDEX,
+                                       fileref->dc->index, di2, disize, Batch_Insert);
+       if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item_batch returned %08x\n", Status);
+            return Status;
         }
 
         if (fileref->oldutf8.Buffer) {
@@ -5336,10 +6078,137 @@
     return STATUS_SUCCESS;
 }
 
-NTSTATUS STDCALL do_write(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
+static void flush_disk_caches(device_extension* Vcb) {
+    LIST_ENTRY* le;
+    ioctl_context context;
+    ULONG num;
+    
+    context.left = 0;
+    
+    le = Vcb->devices.Flink;
+    
+    while (le != &Vcb->devices) {
+        device* dev = CONTAINING_RECORD(le, device, list_entry);
+        
+        if (dev->devobj && !dev->readonly && dev->can_flush)
+            context.left++;
+        
+        le = le->Flink;
+    }
+    
+    if (context.left == 0)
+        return;
+    
+    num = 0;
+    
+    KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
+    
+    context.stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(ioctl_context_stripe) * context.left, ALLOC_TAG);
+    if (!context.stripes) {
+        ERR("out of memory\n");
+        return;
+    }
+    
+    RtlZeroMemory(context.stripes, sizeof(ioctl_context_stripe) * context.left);
+    
+    le = Vcb->devices.Flink;
+    
+    while (le != &Vcb->devices) {
+        device* dev = CONTAINING_RECORD(le, device, list_entry);
+        
+        if (dev->devobj && !dev->readonly && dev->can_flush) {
+            PIO_STACK_LOCATION IrpSp;
+            ioctl_context_stripe* stripe = &context.stripes[num];
+            
+            RtlZeroMemory(&stripe->apte, sizeof(ATA_PASS_THROUGH_EX));
+            
+            stripe->apte.Length = sizeof(ATA_PASS_THROUGH_EX);
+            stripe->apte.TimeOutValue = 5;
+            stripe->apte.CurrentTaskFile[6] = IDE_COMMAND_FLUSH_CACHE;
+
+            stripe->Irp = IoAllocateIrp(dev->devobj->StackSize, FALSE);
+            
+            if (!stripe->Irp) {
+                ERR("IoAllocateIrp failed\n");
+                goto nextdev;
+            }
+            
+            IrpSp = IoGetNextIrpStackLocation(stripe->Irp);
+            IrpSp->MajorFunction = IRP_MJ_DEVICE_CONTROL;
+            
+            IrpSp->Parameters.DeviceIoControl.IoControlCode = IOCTL_ATA_PASS_THROUGH;
+            IrpSp->Parameters.DeviceIoControl.InputBufferLength = sizeof(ATA_PASS_THROUGH_EX);
+            IrpSp->Parameters.DeviceIoControl.OutputBufferLength = sizeof(ATA_PASS_THROUGH_EX);
+            
+            stripe->Irp->AssociatedIrp.SystemBuffer = &stripe->apte;
+            stripe->Irp->Flags |= IRP_BUFFERED_IO | IRP_INPUT_OPERATION;
+            stripe->Irp->UserBuffer = &stripe->apte;
+            stripe->Irp->UserIosb = &stripe->iosb;
+            
+            IoSetCompletionRoutine(stripe->Irp, ioctl_completion, &context, TRUE, TRUE, TRUE);
+            
+            IoCallDriver(dev->devobj, stripe->Irp);
+            
+nextdev:
+            num++;
+        }
+        
+        le = le->Flink;
+    }
+    
+    KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
+    
+    ExFreePool(context.stripes);
+}
+
+static NTSTATUS flush_changed_dev_stats(device_extension* Vcb, device* dev, PIRP Irp) {
     NTSTATUS Status;
+    KEY searchkey;
+    traverse_ptr tp;
+    ULONG statslen;
+    UINT64* stats;
+    
+    searchkey.obj_id = 0;
+    searchkey.obj_type = TYPE_DEV_STATS;
+    searchkey.offset = dev->devitem.dev_id;
+    
+    Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("find_item returned %08x\n", Status);
+        return Status;
+    }
+    
+    if (!keycmp(tp.item->key, searchkey)) {
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
+    }
+    
+    statslen = sizeof(UINT64) * 5;
+    stats = ExAllocatePoolWithTag(PagedPool, statslen, ALLOC_TAG);
+    if (!stats) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+    
+    RtlCopyMemory(stats, dev->stats, statslen);
+    
+    Status = insert_tree_item(Vcb, Vcb->dev_root, 0, TYPE_DEV_STATS, dev->devitem.dev_id, stats, statslen, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        return Status;
+    }
+    
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS STDCALL do_write2(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     LIST_ENTRY *le, batchlist;
     BOOL cache_changed = FALSE;
+    volume_device_extension* vde;
 #ifdef DEBUG_FLUSH_TIMES
     UINT64 filerefs = 0, fcbs = 0;
     LARGE_INTEGER freq, time1, time2;
@@ -5356,6 +6225,8 @@
     time1 = KeQueryPerformanceCounter(&freq);
 #endif
     
+    ExAcquireResourceExclusiveLite(&Vcb->dirty_filerefs_lock, TRUE);
+    
     while (!IsListEmpty(&Vcb->dirty_filerefs)) {
         dirty_fileref* dirt;
         
@@ -5363,8 +6234,8 @@
         
         dirt = CONTAINING_RECORD(le, dirty_fileref, list_entry);
         
-        flush_fileref(dirt->fileref, &batchlist, Irp, rollback);
-        free_fileref(dirt->fileref);
+        flush_fileref(dirt->fileref, &batchlist, Irp);
+        free_fileref(Vcb, dirt->fileref);
         ExFreePool(dirt);
 
 #ifdef DEBUG_FLUSH_TIMES
@@ -5372,8 +6243,10 @@
 #endif
     }
     
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
+    ExReleaseResourceLite(&Vcb->dirty_filerefs_lock);
     
+    commit_batch_list(Vcb, &batchlist, Irp);
+    
 #ifdef DEBUG_FLUSH_TIMES
     time2 = KeQueryPerformanceCounter(NULL);
 
@@ -5385,6 +6258,8 @@
     // We process deleted streams first, so we don't run over our xattr
     // limit unless we absolutely have to.
     
+    ExAcquireResourceExclusiveLite(&Vcb->dirty_fcbs_lock, TRUE);
+    
     le = Vcb->dirty_fcbs.Flink;
     while (le != &Vcb->dirty_fcbs) {
         dirty_fcb* dirt;
@@ -5396,11 +6271,16 @@
             RemoveEntryList(le);
             
             ExAcquireResourceExclusiveLite(dirt->fcb->Header.Resource, TRUE);
-            flush_fcb(dirt->fcb, FALSE, &batchlist, Irp, rollback);
+            Status = flush_fcb(dirt->fcb, FALSE, &batchlist, Irp);
             ExReleaseResourceLite(dirt->fcb->Header.Resource);
             
             free_fcb(dirt->fcb);
             ExFreePool(dirt);
+            
+            if (!NT_SUCCESS(Status)) {
+                ERR("flush_fcb returned %08x\n", Status);
+                return Status;
+            }
 
 #ifdef DEBUG_FLUSH_TIMES
             fcbs++;
@@ -5421,10 +6301,15 @@
             RemoveEntryList(le);
             
             ExAcquireResourceExclusiveLite(dirt->fcb->Header.Resource, TRUE);
-            flush_fcb(dirt->fcb, FALSE, &batchlist, Irp, rollback);
+            Status = flush_fcb(dirt->fcb, FALSE, &batchlist, Irp);
             ExReleaseResourceLite(dirt->fcb->Header.Resource);
             free_fcb(dirt->fcb);
             ExFreePool(dirt);
+            
+            if (!NT_SUCCESS(Status)) {
+                ERR("flush_fcb returned %08x\n", Status);
+                return Status;
+            }
 
 #ifdef DEBUG_FLUSH_TIMES
             fcbs++;
@@ -5434,8 +6319,10 @@
         le = le2;
     }
     
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
+    ExReleaseResourceLite(&Vcb->dirty_fcbs_lock);
     
+    commit_batch_list(Vcb, &batchlist, Irp);
+    
 #ifdef DEBUG_FLUSH_TIMES
     time2 = KeQueryPerformanceCounter(NULL);
 
